#include <iostream>
#include <fstream>
#include <cstdlib>
#include "enor.h"

using namespace std;

Enor::Enor(const string &fajlnev) {
    f.open(fajlnev.c_str());
    if (f.fail()) {
        cout << "Nem sikerult megnyitni a fajlt!" << endl;
        exit(1);
    }
}

bool idopont(const string &str) {
    return str.size() == 5 && isdigit(str[0]) && isdigit(str[1]) &&
    str[2] == ':' && isdigit(str[3]) && isdigit(str[4]);
}

void Enor::next() {
    if (st == norm) {
        vege = false;
        vetites.cim = jegyVasarlas.cim;
        vetites.terem = jegyVasarlas.terem;
        vetites.idopont = jegyVasarlas.idopont;
        vetites.bevetel = 0;
        vetites.csakDiak = true;
        while (vetites.idopont == jegyVasarlas.idopont && st == norm) {
            int ar = 0;
            if (jegyVasarlas.tipus == "G") {
                ar = 500;
            } else if (jegyVasarlas.tipus == "D") {
                ar = 800;
            } else if (jegyVasarlas.tipus == "F") {
                ar = 1000;
            }
            vetites.bevetel += jegyVasarlas.hely * ar;
            vetites.csakDiak = vetites.csakDiak && jegyVasarlas.tipus == "D";
            read();
        }
    } else {
        vege = true;
    }
}

void Enor::read() {
    string prev_word;
    string word;
    f >> prev_word;
    f >> word;
    if (!f.fail()) {
        st = norm;
        jegyVasarlas.cim = "";
        while (!idopont(word)) {
            if (jegyVasarlas.cim != "") {
                jegyVasarlas.cim += " ";
            }
            jegyVasarlas.cim += prev_word;
            prev_word = word;
            f >> word;
        }
        jegyVasarlas.terem = prev_word;
        jegyVasarlas.idopont = word;
        f >> jegyVasarlas.hely;
        f >> jegyVasarlas.tipus;
    } else {
        st = abnorm;
    }
}
